﻿using Robotc;
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPASmartClient.MorkT
{
    public class GLV_MorkT
    {
        /// <summary>
        /// 咖啡订单队列
        /// </summary>
        public ConcurrentQueue<OrderLocInfo> morkOrderPushesCoffee = new ConcurrentQueue<OrderLocInfo>();

        /// <summary>
        /// 冰淇淋订单队列
        /// </summary>
        public ConcurrentQueue<OrderLocInfo> morkOrderPushesIceCream = new ConcurrentQueue<OrderLocInfo>();
        /// <summary>
        /// 物料存放位置
        /// </summary>
        public Dictionary<string, PolymerBatching> batchings = new Dictionary<string, PolymerBatching>();

        /// <summary>
        /// 当前正在制作咖啡
        /// </summary>
        public OrderLocInfo MakeCoffeeOrder = new OrderLocInfo();

        /// <summary>
        /// 获取乐百机器人的数据
        /// </summary>
        public SignalResult lebai = new SignalResult();

        /// <summary>
        /// 咖啡机位置是否有咖啡在制作中
        /// </summary>
        public bool IsCoffeeMake = false;
        /// <summary>
        /// 冰淇淋机器出料口传感器检测
        /// </summary>
        public bool IceIsOK = true;
    }
}
