﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPASmartClient.IoT
{
    /// <summary>
    /// 设备信息表
    /// </summary>
    public class DeviceTable : BaseEntity
    {
        /// <summary>
        /// 阿里云设备key
        /// </summary>
        public string productkey { get; set; }
        /// <summary>
        /// 阿里云设备secret
        /// </summary>
        public string devicesecret { get; set; }
        /// <summary>
        /// 客户端类型
        /// </summary>
        public string devtype { get; set; }
        /// <summary>
        /// 经度
        /// </summary>
        public string jd { get; set; }
        /// <summary>
        /// 维度
        /// </summary>
        public string wd { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string remark { get; set; }
    }
}
