﻿using BPA.Message.Enum;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPASmartClient.Model
{
    /// <summary>
    /// 订单状态改变事件
    /// </summary>
    public class OrderStatusChangedEvent : BaseEvent
    {
        /// <summary>
        /// 子订单ID
        /// </summary>
        public string SubOrderId { get; set; }
        /// <summary>
        /// 状态
        /// </summary>
        public ORDER_STATUS Status { get; set; }

        /// <summary>
        /// 商品名称
        /// </summary>
        public string GoodName { get; set; }
    }
}
